import { ElementRef, TemplateRef } from '@angular/core';
import { TableController, VirtualScrollComponent } from '@lightweightform/core';
import { ObservableMap } from 'mobx';
import { FieldComponentCommon } from '../create-field-component';
import { TableHeaderComponent } from './table-header/table-header.component';
declare const TableComponent_base: typeof TableController & (new (...args: any[]) => FieldComponentCommon);
export declare class TableComponent extends TableComponent_base implements FieldComponentCommon {
    addRowText: string;
    removeRowsText: string;
    noRowsText: string;
    rowHeight: number;
    maxVisibleRows: number;
    excessRows: number;
    headerTemplate: TemplateRef<any>;
    rowTemplate: TemplateRef<any>;
    noRowsTemplate: TemplateRef<any>;
    headerTableContainer: ElementRef;
    bodyTableContainer: ElementRef;
    virtualScroll: VirtualScrollComponent;
    protected _tableHeaderController: TableHeaderComponent | null;
    protected _selectedRows: ObservableMap<boolean>;
    protected _lastSelectedIndex: number | null;
    protected _disposeOnParentFormActivate: () => void;
    protected _disposeScroll: () => void;
    numberOfColumns(includeScrollbarColumn: boolean): number | null;
    tableMinWidth(includeScrollbarColumn: boolean): number | null;
    tableMaxWidth(includeScrollbarColumn: boolean): number | null;
    columnWidths(includeScrollbarColumn: boolean): string[];
    readonly verticalScrollbarWidth: number;
    readonly isEditable: boolean;
    readonly numberOfRowsSelected: number;
    readonly allRowsSelected: boolean;
    readonly noRowsSelected: boolean;
    getRowSelectedStatus(index: number): boolean;
    pushRow(): void;
    setRowSelectedStatus(index: number, selectedStatus: boolean): void;
    setRowSelectedStatusFromLastSelected(index: number, selectedStatus: boolean): void;
    unselectAllRows(): void;
    setAllRowsSelectedStatus(selectedStatus: boolean): void;
    toggleAllRowsSelectedStatus(): void;
    removeSelectedRows(): void;
    _onClickRemoveRows(): void;
    _onClickNewRow(): void;
    protected lfOnComponentInit(): void;
    protected lfAfterComponentViewInit(): void;
    protected lfOnComponentDestroy(): void;
}
